From: Bobby Eshleman <bobbyeshleman@gmail.com>
To: "Stefano Garzarella" <sgarzare@redhat.com>,
"Shuah Khan" <shuah@kernel.org>,
"David S. Miller" <davem@davemloft.net>,
"Eric Dumazet" <edumazet@google.com>,
"Jakub Kicinski" <kuba@kernel.org>,
"Paolo Abeni" <pabeni@redhat.com>,
"Simon Horman" <horms@kernel.org>,
"Stefan Hajnoczi" <stefanha@redhat.com>,
"Michael S. Tsirkin" <mst@redhat.com>,
"Jason Wang" <jasowang@redhat.com>,
"Xuan Zhuo" <xuanzhuo@linux.alibaba.com>,
"Eugenio Pérez" <eperezma@redhat.com>,
"K. Y. Srinivasan" <kys@microsoft.com>,
"Haiyang Zhang" <haiyangz@microsoft.com>,
"Wei Liu" <wei.liu@kernel.org>,
"Dexuan Cui" <decui@microsoft.com>,
"Bryan Tan" <bryan-bt.tan@broadcom.com>,
"Vishnu Dasa" <vishnu.dasa@broadcom.com>,
"Broadcom internal kernel review list"
<bcm-kernel-feedback-list@broadcom.com>,
"Bobby Eshleman" <bobbyeshleman@gmail.com>
Cc: virtualization@lists.linux.dev, netdev@vger.kernel.org,
linux-kselftest@vger.kernel.org, linux-kernel@vger.kernel.org,
kvm@vger.kernel.org, linux-hyperv@vger.kernel.org,
berrange@redhat.com, Bobby Eshleman <bobbyeshleman@meta.com>
Subject: [PATCH net-next v7 25/26] selftests/vsock: add tests for module loading order
Date: Tue, 21 Oct 2025 16:47:08 -0700 [thread overview]
Message-ID: <20251021-vsock-vmtest-v7-25-0661b7b6f081@meta.com> (raw)
In-Reply-To: <20251021-vsock-vmtest-v7-0-0661b7b6f081@meta.com>
From: Bobby Eshleman <bobbyeshleman@meta.com>
Add tests to check that module loading order does not break
vsock_loopback. Because vsock_loopback has some per-namespace data
structure initialization that affects vsock namespace modes, lets make
sure that namespace modes are respected and loopback sockets are
functional even when the namespaces and modes are set prior to loading
the vsock_loopback module.
Signed-off-by: Bobby Eshleman <bobbyeshleman@meta.com>
---
tools/testing/selftests/vsock/vmtest.sh | 131 ++++++++++++++++++++++++++++++++
1 file changed, 131 insertions(+)
diff --git a/tools/testing/selftests/vsock/vmtest.sh b/tools/testing/selftests/vsock/vmtest.sh
index f8fa8b16d6e3..648ae71bf45a 100755
--- a/tools/testing/selftests/vsock/vmtest.sh
+++ b/tools/testing/selftests/vsock/vmtest.sh
@@ -68,6 +68,8 @@ readonly TEST_NAMES=(
ns_delete_vm_ok
ns_delete_host_ok
ns_delete_both_ok
+ ns_loopback_global_global_late_module_load_ok
+ ns_loopback_local_local_late_module_load_fails
)
readonly TEST_DESCS=(
# vm_server_host_client
@@ -153,6 +155,12 @@ readonly TEST_DESCS=(
# ns_delete_both_ok
"Check that deleting the VM and host's namespaces does not break the socket connection"
+
+ # ns_loopback_global_global_late_module_load_ok
+ "Test that loopback still works in global namespaces initialized prior to loading the vsock_loopback kmod"
+
+ # ns_loopback_local_local_late_module_load_fails
+ "Test that loopback connections still fail between local namespaces initialized prior to loading the vsock_loopback kmod"
)
readonly USE_SHARED_VM=(vm_server_host_client vm_client_host_server vm_loopback)
@@ -912,6 +920,23 @@ test_ns_diff_local_vm_connect_to_local_host_fails() {
return "${KSFT_FAIL}"
}
+unload_module() {
+ local module=$1
+ local i
+
+ for ((i = 0; i < 5; i++)); do
+ modprobe -r "${module}" 2>/dev/null || :
+
+ if [[ "$(lsmod | grep -c ${module})" -eq 0 ]]; then
+ return 0
+ fi
+
+ sleep 1
+ done
+
+ return 1
+}
+
__test_loopback_two_netns() {
local ns0=$1
local ns1=$2
@@ -1264,6 +1289,112 @@ test_ns_delete_both_ok() {
check_ns_changes_dont_break_connection "both" "delete"
}
+test_ns_loopback_global_global_late_module_load_ok() {
+ declare -a pids
+ local unixfile
+ local ns0 ns1
+ local pids
+ local port
+
+ if ! unload_module vsock_loopback; then
+ log_host "Unable to unload vsock_loopback, skipping..."
+ return "${KSFT_SKIP}"
+ fi
+
+ ns0=loopback_ns0
+ ns1=loopback_ns1
+
+ ip netns del "${ns0}" &>/dev/null || :
+ ip netns del "${ns1}" &>/dev/null || :
+ ip netns add "${ns0}"
+ ip netns add "${ns1}"
+ ns_set_mode "${ns0}" global
+ ns_set_mode "${ns1}" global
+ ip netns exec "${ns0}" ip link set dev lo up
+ ip netns exec "${ns1}" ip link set dev lo up
+
+ modprobe vsock_loopback &> /dev/null || :
+
+ unixfile=$(mktemp -u /tmp/XXXX.sock)
+ port=321
+ ip netns exec "${ns1}" \
+ socat TCP-LISTEN:"${port}",fork \
+ UNIX-CONNECT:"${unixfile}" &
+ pids+=($!)
+
+ host_wait_for_listener "${ns1}" "${port}"
+ ip netns exec "${ns0}" socat UNIX-LISTEN:"${unixfile}",fork \
+ TCP-CONNECT:localhost:"${port}" &
+ pids+=($!)
+
+ if ! host_vsock_test "${ns0}" "server" 1 "${port}"; then
+ ip netns del "${ns0}" &>/dev/null || :
+ ip netns del "${ns1}" &>/dev/null || :
+ terminate_pids "${pids[@]}"
+ return "${KSFT_FAIL}"
+ fi
+
+ if ! host_vsock_test "${ns1}" "127.0.0.1" 1 "${port}"; then
+ ip netns del "${ns0}" &>/dev/null || :
+ ip netns del "${ns1}" &>/dev/null || :
+ terminate_pids "${pids[@]}"
+ return "${KSFT_FAIL}"
+ fi
+
+ ip netns del "${ns0}" &>/dev/null || :
+ ip netns del "${ns1}" &>/dev/null || :
+ terminate_pids "${pids[@]}"
+
+ return "${KSFT_PASS}"
+}
+
+test_ns_loopback_local_local_late_module_load_fails() {
+ declare -a pids
+ local ns0 ns1
+ local outfile
+ local pids
+ local rc
+
+ if ! unload_module vsock_loopback; then
+ log_host "Unable to unload vsock_loopback, skipping..."
+ return "${KSFT_SKIP}"
+ fi
+
+ ns0=loopback_ns0
+ ns1=loopback_ns1
+
+ ip netns del "${ns0}" &>/dev/null || :
+ ip netns del "${ns1}" &>/dev/null || :
+ ip netns add "${ns0}"
+ ip netns add "${ns1}"
+ ns_set_mode "${ns0}" local
+ ns_set_mode "${ns1}" local
+
+ modprobe vsock_loopback &> /dev/null || :
+
+ outfile=$(mktemp /tmp/XXXX.vmtest.out)
+ ip netns exec "${ns0}" socat VSOCK-LISTEN:${port} STDOUT \
+ > "${outfile}" 2>/dev/null &
+ pids+=($!)
+
+ echo TEST | \
+ ip netns exec "${ns1}" socat STDIN VSOCK-CONNECT:1:${port} \
+ 2>/dev/null
+
+ if grep -q "TEST" "${outfile}" 2>/dev/null; then
+ rc="${KSFT_FAIL}"
+ else
+ rc="${KSFT_PASS}"
+ fi
+
+ ip netns del "${ns0}" &>/dev/null || :
+ ip netns del "${ns1}" &>/dev/null || :
+ terminate_pids "${pids[@]}"
+ rm -f "${outfile}"
+
+ return "${rc}"
+}
+
shared_vm_test() {
local tname
--
2.47.3
next prev parent reply other threads:[~2025-10-21 23:47 UTC|newest]
Thread overview: 29+ messages / expand[flat|nested] mbox.gz Atom feed top
2025-10-21 23:46 [PATCH net-next v7 00/26] vsock: add namespace support to vhost-vsock Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 01/26] vsock: a per-net vsock NS mode state Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 02/26] vsock/virtio: pack struct virtio_vsock_skb_cb Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 03/26] vsock: add netns to vsock skb cb Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 04/26] vsock: add netns to vsock core Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 05/26] vsock/loopback: add netns support Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 06/26] vsock/virtio: add netns to virtio transport common Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 07/26] vhost/vsock: add netns support Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 08/26] selftests/vsock: improve logging in vmtest.sh Bobby Eshleman
2025-10-22 0:01 ` Jakub Kicinski
2025-10-22 0:18 ` Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 09/26] selftests/vsock: make wait_for_listener() work even if pipefail is on Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 10/26] selftests/vsock: reuse logic for vsock_test through wrapper functions Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 11/26] selftests/vsock: avoid multi-VM pidfile collisions with QEMU Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 12/26] selftests/vsock: do not unconditionally die if qemu fails Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 13/26] selftests/vsock: speed up tests by reducing the QEMU pidfile timeout Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 14/26] selftests/vsock: add check_result() for pass/fail counting Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 15/26] selftests/vsock: identify and execute tests that can re-use VM Bobby Eshleman
2025-10-21 23:46 ` [PATCH net-next v7 16/26] selftests/vsock: add namespace initialization function Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 17/26] selftests/vsock: remove namespaces in cleanup() Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 18/26] selftests/vsock: prepare vm management helpers for namespaces Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 19/26] selftests/vsock: add BUILD=0 definition Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 20/26] selftests/vsock: avoid false-positives when checking dmesg Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 21/26] selftests/vsock: add tests for proc sys vsock ns_mode Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 22/26] selftests/vsock: add namespace tests for CID collisions Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 23/26] selftests/vsock: add tests for host <-> vm connectivity with namespaces Bobby Eshleman
2025-10-21 23:47 ` [PATCH net-next v7 24/26] selftests/vsock: add tests for namespace deletion and mode changes Bobby Eshleman
2025-10-21 23:47 ` Bobby Eshleman [this message]
2025-10-21 23:47 ` [PATCH net-next v7 26/26] selftests/vsock: add 1.37 to tested virtme-ng versions Bobby Eshleman
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20251021-vsock-vmtest-v7-25-0661b7b6f081@meta.com \
--to=bobbyeshleman@gmail.com \
--cc=bcm-kernel-feedback-list@broadcom.com \
--cc=berrange@redhat.com \
--cc=bobbyeshleman@meta.com \
--cc=bryan-bt.tan@broadcom.com \
--cc=davem@davemloft.net \
--cc=decui@microsoft.com \
--cc=edumazet@google.com \
--cc=eperezma@redhat.com \
--cc=haiyangz@microsoft.com \
--cc=horms@kernel.org \
--cc=jasowang@redhat.com \
--cc=kuba@kernel.org \
--cc=kvm@vger.kernel.org \
--cc=kys@microsoft.com \
--cc=linux-hyperv@vger.kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=linux-kselftest@vger.kernel.org \
--cc=mst@redhat.com \
--cc=netdev@vger.kernel.org \
--cc=pabeni@redhat.com \
--cc=sgarzare@redhat.com \
--cc=shuah@kernel.org \
--cc=stefanha@redhat.com \
--cc=virtualization@lists.linux.dev \
--cc=vishnu.dasa@broadcom.com \
--cc=wei.liu@kernel.org \
--cc=xuanzhuo@linux.alibaba.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox